/************************************************************************
	spi.c

    LED String Colour Organ
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

// Global includes
#include <htc.h>

// Local includes
#include "hardware.h"
#include "spi.h"

// Set the level of the MP41010 digital pot controlling the input gain
void setGainLevel(unsigned char gainLevel)
{
	// Set up SPI for the MP41010
	SSPSTAT = 0b11000000;	// SPI Master
							// Tx occurs on idle to active transition

	SSPCON1 = 0b00100000;	// Serial port enabled
							// Speed is Fosc/4

	// Enable chip serial
	RB5 = 0;

	// Send SET command
	SSPIF = 0;
	SSPBUF = 0b00010011;
	while(!SSPIF); // Wait for transmit to complete

	// Send gain level
	SSPIF = 0;
	SSPBUF = gainLevel;
	while(!SSPIF); // Wait for transmit to complete

	// Disable chip serial
	RB5 = 1;
}